#define _GNU_SOURCE 1
#include <dlfcn.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>

void _spio_init(void) __attribute__ ((constructor));
void _spio_fini(void) __attribute__ ((destructor));

static void *libc_handle = NULL;
static int (*real_open)(const char *pathname,int flags,mode_t mode);
static int (*real_open64)(const char *pathname,int flags,mode_t mode);

void _spio_init(void)
{
   printf("_spio_init\n");
#ifdef RTLD_NEXT
#warning RTLD_NEXT
      libc_handle = RTLD_NEXT;
#else
      libc_handle = dlopen("libc.so.6",RTLD_LAZY);
#endif   
      real_open = dlsym(libc_handle,"open");
      real_open64 = dlsym(libc_handle,"open");
      printf("libc_handle=%p real=%p real64=%p\n",libc_handle,real_open,real_open64);
}

void _spio_fini(void)
{
   printf("_spio_fini\n");
}


int open(const char *pathname,int flags,...)
{
   va_list ap;
   mode_t mode;
   va_start(ap,flags);
   mode = va_arg(ap, mode_t);
   va_end(ap);

   printf("intercept open(%s,%x,%x)\n",pathname,flags,mode);
   int ret = (*real_open)(pathname,flags,mode);
   return ret;
}

int open64(const char *pathname,int flags,...)
{
   va_list ap;
   mode_t mode;
   va_start(ap,flags);
   mode = va_arg(ap, mode_t);
   va_end(ap);

   printf("intercept open64(%s,%x,%x)\n",pathname,flags,mode);
   int ret = (*real_open64)(pathname,flags,mode);
   return ret;
}
